subroutine getenv( name , value )
!
!*****************************************************************************!
!                                                                             !
!            Author : J.Jansen               Date : 4 March 1998              !
!    Revision : 1.0          Author : J.Jansen       Date : 5 April 2000      !
!    Revision : 1.1          Author : J.Jansen       Date : 18 October 2000   !
!    Revision : 1.2          Author : J.Jansen       Date : 30 September 2002 !
!    Revision : 1.3          Author : J.Jansen       Date : 29 August 2003    !
!                                                                             !
!-----------------------------------------------------------------------------!
!                                                                             !
! Subroutine to get Logicals (environement parameters)                        !
!                                                                             !
! OpenVMS version                                                             !
!                                                                             !
!*****************************************************************************!
!
!DEC$ ATTRIBUTES ALIAS:'LIB$SIGNAL' :: lib$signal
!DEC$ ATTRIBUTES ALIAS:'SYS$TRNLNM' :: sys$trnlnm
!
  implicit none
!
  include '($lnmdef)/list'
!
  include '($ssdef)/list'
!
  character ( len = * ) :: name , value
!
  structure /itmlst/
    union
      map
        integer*2 buffer_length , item_code
        integer*4 buffer_adress , return_adress
      end map
      map
        integer*4 end_list
      end map
    end union
  end structure
!
  record /itmlst/ item( 3 )
  integer( kind = 4 ) :: ierr , i , j , lbuffer
  character ( len = 20 ) :: tables( 5 )
  character ( len = 255 ) :: buffer
!
  integer( kind = 4 ) , external :: sys$trnlnm
!
  tables( 1 ) = 'LNM$JOB_TABLE'
  tables( 2 ) = 'LNM$PROCESS_TABLE'
  tables( 3 ) = 'LNM$SYSTEM_TABLE'
  tables( 4 ) = 'LNM$GROUP_TABLE'
  tables( 5 ) = '$DECW$LOGICAL_NAMES'
!
! Initialize item list
  item( 1 ).buffer_length = 255
  item( 1 ).item_code = lnm$_string
  item( 1 ).buffer_adress = %loc( buffer )
  item( 1 ).return_adress = 0
  item( 2 ).buffer_length = 4
  item( 2 ).item_code = lnm$_length
  item( 2 ).buffer_adress = %loc( lbuffer )
  item( 2 ).return_adress = 0
  item( 3 ).end_list = 0
!
! Get number of indices
  do i = 1 , 5
    j = 20
    do while ( j >= 1 )
      if ( tables( i )( j:j ) /= ' ' ) exit
      j = j - 1
    end do
    if ( j == 0 ) cycle
    ierr = sys$trnlnm( , tables( i )( 1:j ) , name , , item )
    if ( ierr == ss$_normal ) then
      lbuffer = min( len( value ) , lbuffer )
      value = buffer( 1:lbuffer )
      return
    else if ( ierr /= ss$_nolognam ) then
      call lib$signal( %val( ierr ) )
    end if
  end do
  value = ' '
!
  return
end
